<?php

namespace App\Distributor\Repositories;

use App\Models\DistProductCategory as Model;

use App\Models\DistProductParameter;
use Dcat\Admin\Repositories\EloquentRepository;

class DistProductCategory extends EloquentRepository
{
    /**
     * Model.
     *
     * @var string
     */
    protected $eloquentClass = Model::class;


    // 调用模型方法
    public static function selectMainOptions(\Closure $closure = null)
    {

        $query = Model::query();

        if ($closure) {
            $closure($query);
        }

        // 确保查询构造器不为空
        if (!$query) {
            return [];
        }

        // 返回键值对数组，并按 'name' 和 'order' 字段排序
        $results = $query->orderBy('name')->orderBy('order')->pluck('name', 'id');

        // 在每个 name 前面加上 '├─'
        $results = $results->map(function ($name) {
            return '├─' . $name;
        });

        return $results->all();

    }

    // 调用模型方法
    public static function selectOptions(\Closure $closure = null)
    {
        $selectOptions = Model::class::selectOptions($closure);
        return $selectOptions;
    }


    public static function getParameter($categoryId)
    {
        $categoryRow =  Model::Class::find($categoryId);
        if ($categoryRow->baseProductParameter) {
            return $categoryRow->baseProductParameter->content;
        } else {
            return "[]";
        }
    }

    /**
     * @param Grid\Model|\Dcat\Admin\Grid\Model $model
     * @return array
     */
    public function get(Grid\Model|\Dcat\Admin\Grid\Model $model)
    {

        $obj = $this->model();



        $obj->where('dist_user_id',0);

        // 将树结构转换为数组
        $tree = $obj->get();

      // var_dump($tree->toArray());

        $data=buildTree($tree->toArray());

        $data=flattenTree($data);

        return $model->makePaginator(
            1, // 传入总记录数
            $data // 传入数据二维数组
        );
    }


}
